diff --git a/MAINTAINERS b/MAINTAINERS
index 848640546398..84bc106acc57 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -4771,7 +4771,7 @@ M:	Philipp Zabel <p.zabel@pengutronix.de>
 L:	linux-media@vger.kernel.org
 S:	Maintained
 F:	Documentation/devicetree/bindings/media/coda.yaml
-F:	drivers/media/platform/coda/
+F:	drivers/media/platform/chips-media/
 
 CODE OF CONDUCT
 M:	Greg Kroah-Hartman <gregkh@linuxfoundation.org>
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index f15ab9739823..615736ac117c 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -71,7 +71,7 @@ source "drivers/media/platform/amphion/Kconfig"
 source "drivers/media/platform/aspeed/Kconfig"
 source "drivers/media/platform/atmel/Kconfig"
 source "drivers/media/platform/cadence/Kconfig"
-source "drivers/media/platform/coda/Kconfig"
+source "drivers/media/platform/chips-media/Kconfig"
 source "drivers/media/platform/davinci/Kconfig"
 source "drivers/media/platform/exynos-gsc/Kconfig"
 source "drivers/media/platform/exynos4-is/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index 20b07ae3ebf1..8d6e15fad0b1 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -6,12 +6,12 @@
 # Place here, alphabetically sorted by directory
 # (e. g. LC_ALL=C sort Makefile)
 obj-y += allegro-dvt/
-obj-y += aspeed/
 obj-y += am437x/
 obj-y += amphion/
+obj-y += aspeed/
 obj-y += atmel/
 obj-y += cadence/
-obj-y += coda/
+obj-y += chips-media/
 obj-y += davinci/
 obj-y += exynos-gsc/
 obj-y += exynos4-is/
diff --git a/drivers/media/platform/coda/Kconfig b/drivers/media/platform/chips-media/Kconfig
similarity index 100%
rename from drivers/media/platform/coda/Kconfig
rename to drivers/media/platform/chips-media/Kconfig
diff --git a/drivers/media/platform/coda/Makefile b/drivers/media/platform/chips-media/Makefile
similarity index 100%
rename from drivers/media/platform/coda/Makefile
rename to drivers/media/platform/chips-media/Makefile
diff --git a/drivers/media/platform/coda/coda-bit.c b/drivers/media/platform/chips-media/coda-bit.c
similarity index 100%
rename from drivers/media/platform/coda/coda-bit.c
rename to drivers/media/platform/chips-media/coda-bit.c
diff --git a/drivers/media/platform/coda/coda-common.c b/drivers/media/platform/chips-media/coda-common.c
similarity index 100%
rename from drivers/media/platform/coda/coda-common.c
rename to drivers/media/platform/chips-media/coda-common.c
diff --git a/drivers/media/platform/coda/coda-gdi.c b/drivers/media/platform/chips-media/coda-gdi.c
similarity index 100%
rename from drivers/media/platform/coda/coda-gdi.c
rename to drivers/media/platform/chips-media/coda-gdi.c
diff --git a/drivers/media/platform/coda/coda-h264.c b/drivers/media/platform/chips-media/coda-h264.c
similarity index 100%
rename from drivers/media/platform/coda/coda-h264.c
rename to drivers/media/platform/chips-media/coda-h264.c
diff --git a/drivers/media/platform/coda/coda-jpeg.c b/drivers/media/platform/chips-media/coda-jpeg.c
similarity index 100%
rename from drivers/media/platform/coda/coda-jpeg.c
rename to drivers/media/platform/chips-media/coda-jpeg.c
diff --git a/drivers/media/platform/coda/coda-mpeg2.c b/drivers/media/platform/chips-media/coda-mpeg2.c
similarity index 100%
rename from drivers/media/platform/coda/coda-mpeg2.c
rename to drivers/media/platform/chips-media/coda-mpeg2.c
diff --git a/drivers/media/platform/coda/coda-mpeg4.c b/drivers/media/platform/chips-media/coda-mpeg4.c
similarity index 100%
rename from drivers/media/platform/coda/coda-mpeg4.c
rename to drivers/media/platform/chips-media/coda-mpeg4.c
diff --git a/drivers/media/platform/coda/coda.h b/drivers/media/platform/chips-media/coda.h
similarity index 100%
rename from drivers/media/platform/coda/coda.h
rename to drivers/media/platform/chips-media/coda.h
diff --git a/drivers/media/platform/coda/coda_regs.h b/drivers/media/platform/chips-media/coda_regs.h
similarity index 99%
rename from drivers/media/platform/coda/coda_regs.h
rename to drivers/media/platform/chips-media/coda_regs.h
index da5bb3212528..db81a904cf3f 100644
--- a/drivers/media/platform/coda/coda_regs.h
+++ b/drivers/media/platform/chips-media/coda_regs.h
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
- * linux/drivers/media/platform/coda/coda_regs.h
+ * linux/drivers/media/platform/chips-media/coda_regs.h
  *
  * Copyright (C) 2012 Vista Silicon SL
  *    Javier Martin <javier.martin@vista-silicon.com>
diff --git a/drivers/media/platform/coda/imx-vdoa.c b/drivers/media/platform/chips-media/imx-vdoa.c
similarity index 100%
rename from drivers/media/platform/coda/imx-vdoa.c
rename to drivers/media/platform/chips-media/imx-vdoa.c
diff --git a/drivers/media/platform/coda/imx-vdoa.h b/drivers/media/platform/chips-media/imx-vdoa.h
similarity index 100%
rename from drivers/media/platform/coda/imx-vdoa.h
rename to drivers/media/platform/chips-media/imx-vdoa.h
diff --git a/drivers/media/platform/coda/trace.h b/drivers/media/platform/chips-media/trace.h
similarity index 98%
rename from drivers/media/platform/coda/trace.h
rename to drivers/media/platform/chips-media/trace.h
index c0791c847f7c..19f98e6dafb9 100644
--- a/drivers/media/platform/coda/trace.h
+++ b/drivers/media/platform/chips-media/trace.h
@@ -167,7 +167,7 @@ DEFINE_EVENT(coda_buf_class, coda_jpeg_done,
 #endif /* __CODA_TRACE_H__ */
 
 #undef TRACE_INCLUDE_PATH
-#define TRACE_INCLUDE_PATH ../../drivers/media/platform/coda
+#define TRACE_INCLUDE_PATH ../../drivers/media/platform/chips-media
 #undef TRACE_INCLUDE_FILE
 #define TRACE_INCLUDE_FILE trace
 