diff --git a/MAINTAINERS b/MAINTAINERS
index 58e0d42b1278..f29195850c16 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -750,7 +750,7 @@ L:	linux-media@vger.kernel.org
 S:	Maintained
 T:	git git://linuxtv.org/media_tree.git
 F:	Documentation/devicetree/bindings/media/allwinner,sun4i-a10-csi.yaml
-F:	drivers/media/platform/sunxi/sun4i-csi/
+F:	drivers/media/platform/allwinner/sun4i-csi/
 
 ALLWINNER CPUFREQ DRIVER
 M:	Yangtao Li <tiny.windzz@gmail.com>
@@ -5114,7 +5114,7 @@ L:	linux-media@vger.kernel.org
 S:	Maintained
 T:	git git://linuxtv.org/media_tree.git
 F:	Documentation/devicetree/bindings/media/allwinner,sun6i-a31-csi.yaml
-F:	drivers/media/platform/sunxi/sun6i-csi/
+F:	drivers/media/platform/allwinner/sun6i-csi/
 
 CW1200 WLAN driver
 M:	Solomon Peachy <pizza@shaftnet.org>
@@ -5391,7 +5391,7 @@ L:	linux-media@vger.kernel.org
 S:	Maintained
 T:	git git://linuxtv.org/media_tree.git
 F:	Documentation/devicetree/bindings/media/allwinner,sun8i-h3-deinterlace.yaml
-F:	drivers/media/platform/sunxi/sun8i-di/
+F:	drivers/media/platform/allwinner/sun8i-di/
 
 DELL LAPTOP DRIVER
 M:	Matthew Garrett <mjg59@srcf.ucam.org>
@@ -16746,7 +16746,7 @@ L:	linux-media@vger.kernel.org
 S:	Maintained
 T:	git git://linuxtv.org/media_tree.git
 F:	Documentation/devicetree/bindings/media/allwinner,sun8i-a83t-de2-rotate.yaml
-F:	drivers/media/platform/sunxi/sun8i-rotate/
+F:	drivers/media/platform/allwinner/sun8i-rotate/
 
 RPMSG TTY DRIVER
 M:	Arnaud Pouliquen <arnaud.pouliquen@foss.st.com>
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index 33f8f41b2771..5ffbbd6c6f91 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -66,6 +66,7 @@ config VIDEO_MUX
 # TODO: create per-manufacturer directories
 
 source "drivers/media/platform/allegro-dvt/Kconfig"
+source "drivers/media/platform/allwinner/Kconfig"
 source "drivers/media/platform/am437x/Kconfig"
 source "drivers/media/platform/amlogic/meson-ge2d/Kconfig"
 source "drivers/media/platform/amphion/Kconfig"
@@ -94,7 +95,6 @@ source "drivers/media/platform/s5p-jpeg/Kconfig"
 source "drivers/media/platform/s5p-mfc/Kconfig"
 source "drivers/media/platform/sti/Kconfig"
 source "drivers/media/platform/stm32/Kconfig"
-source "drivers/media/platform/sunxi/Kconfig"
 source "drivers/media/platform/tegra/vde/Kconfig"
 source "drivers/media/platform/ti-vpe/Kconfig"
 source "drivers/media/platform/via/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index 954ad8f2cde1..88519e902919 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -6,6 +6,7 @@
 # Place here, alphabetically sorted by directory
 # (e. g. LC_ALL=C sort Makefile)
 obj-y += allegro-dvt/
+obj-y += allwinner/
 obj-y += am437x/
 obj-y += amlogic/meson-ge2d/
 obj-y += amphion/
@@ -39,7 +40,6 @@ obj-y += sti/c8sectpfe/
 obj-y += sti/delta/
 obj-y += sti/hva/
 obj-y += stm32/
-obj-y += sunxi/
 obj-y += tegra/vde/
 obj-y += ti-vpe/
 obj-y += via/
diff --git a/drivers/media/platform/allwinner/Kconfig b/drivers/media/platform/allwinner/Kconfig
new file mode 100644
index 000000000000..88bffb055528
--- /dev/null
+++ b/drivers/media/platform/allwinner/Kconfig
@@ -0,0 +1,6 @@
+# SPDX-License-Identifier: GPL-2.0
+
+source "drivers/media/platform/allwinner/sun4i-csi/Kconfig"
+source "drivers/media/platform/allwinner/sun6i-csi/Kconfig"
+source "drivers/media/platform/allwinner/sun8i-di/Kconfig"
+source "drivers/media/platform/allwinner/sun8i-rotate/Kconfig"
diff --git a/drivers/media/platform/sunxi/Makefile b/drivers/media/platform/allwinner/Makefile
similarity index 100%
rename from drivers/media/platform/sunxi/Makefile
rename to drivers/media/platform/allwinner/Makefile
diff --git a/drivers/media/platform/sunxi/sun4i-csi/Kconfig b/drivers/media/platform/allwinner/sun4i-csi/Kconfig
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/Kconfig
rename to drivers/media/platform/allwinner/sun4i-csi/Kconfig
diff --git a/drivers/media/platform/sunxi/sun4i-csi/Makefile b/drivers/media/platform/allwinner/sun4i-csi/Makefile
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/Makefile
rename to drivers/media/platform/allwinner/sun4i-csi/Makefile
diff --git a/drivers/media/platform/sunxi/sun4i-csi/sun4i_csi.c b/drivers/media/platform/allwinner/sun4i-csi/sun4i_csi.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/sun4i_csi.c
rename to drivers/media/platform/allwinner/sun4i-csi/sun4i_csi.c
diff --git a/drivers/media/platform/sunxi/sun4i-csi/sun4i_csi.h b/drivers/media/platform/allwinner/sun4i-csi/sun4i_csi.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/sun4i_csi.h
rename to drivers/media/platform/allwinner/sun4i-csi/sun4i_csi.h
diff --git a/drivers/media/platform/sunxi/sun4i-csi/sun4i_dma.c b/drivers/media/platform/allwinner/sun4i-csi/sun4i_dma.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/sun4i_dma.c
rename to drivers/media/platform/allwinner/sun4i-csi/sun4i_dma.c
diff --git a/drivers/media/platform/sunxi/sun4i-csi/sun4i_v4l2.c b/drivers/media/platform/allwinner/sun4i-csi/sun4i_v4l2.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun4i-csi/sun4i_v4l2.c
rename to drivers/media/platform/allwinner/sun4i-csi/sun4i_v4l2.c
diff --git a/drivers/media/platform/sunxi/sun6i-csi/Kconfig b/drivers/media/platform/allwinner/sun6i-csi/Kconfig
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/Kconfig
rename to drivers/media/platform/allwinner/sun6i-csi/Kconfig
diff --git a/drivers/media/platform/sunxi/sun6i-csi/Makefile b/drivers/media/platform/allwinner/sun6i-csi/Makefile
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/Makefile
rename to drivers/media/platform/allwinner/sun6i-csi/Makefile
diff --git a/drivers/media/platform/sunxi/sun6i-csi/sun6i_csi.c b/drivers/media/platform/allwinner/sun6i-csi/sun6i_csi.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/sun6i_csi.c
rename to drivers/media/platform/allwinner/sun6i-csi/sun6i_csi.c
diff --git a/drivers/media/platform/sunxi/sun6i-csi/sun6i_csi.h b/drivers/media/platform/allwinner/sun6i-csi/sun6i_csi.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/sun6i_csi.h
rename to drivers/media/platform/allwinner/sun6i-csi/sun6i_csi.h
diff --git a/drivers/media/platform/sunxi/sun6i-csi/sun6i_csi_reg.h b/drivers/media/platform/allwinner/sun6i-csi/sun6i_csi_reg.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/sun6i_csi_reg.h
rename to drivers/media/platform/allwinner/sun6i-csi/sun6i_csi_reg.h
diff --git a/drivers/media/platform/sunxi/sun6i-csi/sun6i_video.c b/drivers/media/platform/allwinner/sun6i-csi/sun6i_video.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/sun6i_video.c
rename to drivers/media/platform/allwinner/sun6i-csi/sun6i_video.c
diff --git a/drivers/media/platform/sunxi/sun6i-csi/sun6i_video.h b/drivers/media/platform/allwinner/sun6i-csi/sun6i_video.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun6i-csi/sun6i_video.h
rename to drivers/media/platform/allwinner/sun6i-csi/sun6i_video.h
diff --git a/drivers/media/platform/sunxi/sun8i-di/Kconfig b/drivers/media/platform/allwinner/sun8i-di/Kconfig
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-di/Kconfig
rename to drivers/media/platform/allwinner/sun8i-di/Kconfig
diff --git a/drivers/media/platform/sunxi/sun8i-di/Makefile b/drivers/media/platform/allwinner/sun8i-di/Makefile
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-di/Makefile
rename to drivers/media/platform/allwinner/sun8i-di/Makefile
diff --git a/drivers/media/platform/sunxi/sun8i-di/sun8i-di.c b/drivers/media/platform/allwinner/sun8i-di/sun8i-di.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-di/sun8i-di.c
rename to drivers/media/platform/allwinner/sun8i-di/sun8i-di.c
diff --git a/drivers/media/platform/sunxi/sun8i-di/sun8i-di.h b/drivers/media/platform/allwinner/sun8i-di/sun8i-di.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-di/sun8i-di.h
rename to drivers/media/platform/allwinner/sun8i-di/sun8i-di.h
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/Kconfig b/drivers/media/platform/allwinner/sun8i-rotate/Kconfig
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/Kconfig
rename to drivers/media/platform/allwinner/sun8i-rotate/Kconfig
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/Makefile b/drivers/media/platform/allwinner/sun8i-rotate/Makefile
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/Makefile
rename to drivers/media/platform/allwinner/sun8i-rotate/Makefile
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/sun8i-formats.h b/drivers/media/platform/allwinner/sun8i-rotate/sun8i-formats.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/sun8i-formats.h
rename to drivers/media/platform/allwinner/sun8i-rotate/sun8i-formats.h
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/sun8i-rotate.h b/drivers/media/platform/allwinner/sun8i-rotate/sun8i-rotate.h
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/sun8i-rotate.h
rename to drivers/media/platform/allwinner/sun8i-rotate/sun8i-rotate.h
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/sun8i_formats.c b/drivers/media/platform/allwinner/sun8i-rotate/sun8i_formats.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/sun8i_formats.c
rename to drivers/media/platform/allwinner/sun8i-rotate/sun8i_formats.c
diff --git a/drivers/media/platform/sunxi/sun8i-rotate/sun8i_rotate.c b/drivers/media/platform/allwinner/sun8i-rotate/sun8i_rotate.c
similarity index 100%
rename from drivers/media/platform/sunxi/sun8i-rotate/sun8i_rotate.c
rename to drivers/media/platform/allwinner/sun8i-rotate/sun8i_rotate.c
diff --git a/drivers/media/platform/sunxi/Kconfig b/drivers/media/platform/sunxi/Kconfig
deleted file mode 100644
index a10032215b08..000000000000
--- a/drivers/media/platform/sunxi/Kconfig
+++ /dev/null
@@ -1,6 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0
-
-source "drivers/media/platform/sunxi/sun4i-csi/Kconfig"
-source "drivers/media/platform/sunxi/sun6i-csi/Kconfig"
-source "drivers/media/platform/sunxi/sun8i-di/Kconfig"
-source "drivers/media/platform/sunxi/sun8i-rotate/Kconfig"