diff --git a/MAINTAINERS b/MAINTAINERS
index c9333d46047e..74901acf8f06 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1037,7 +1037,7 @@ M:	Zhou Peng <eagle.zhou@nxp.com>
 L:	linux-media@vger.kernel.org
 S:	Maintained
 F:	Documentation/devicetree/bindings/media/amphion,vpu.yaml
-F:	drivers/media/platform/amphion/
+F:	drivers/media/platform/nxp/amphion/
 
 AMS AS73211 DRIVER
 M:	Christian Eggers <ceggers@arri.de>
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index 13d8f3e59116..7b88ef15f8c8 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -69,7 +69,6 @@ source "drivers/media/platform/allegro-dvt/Kconfig"
 source "drivers/media/platform/allwinner/Kconfig"
 source "drivers/media/platform/am437x/Kconfig"
 source "drivers/media/platform/amlogic/meson-ge2d/Kconfig"
-source "drivers/media/platform/amphion/Kconfig"
 source "drivers/media/platform/aspeed/Kconfig"
 source "drivers/media/platform/atmel/Kconfig"
 source "drivers/media/platform/cadence/Kconfig"
@@ -85,6 +84,7 @@ source "drivers/media/platform/mediatek/mtk-vcodec/Kconfig"
 source "drivers/media/platform/mediatek/mtk-vpu/Kconfig"
 source "drivers/media/platform/nvidia/tegra-vde/Kconfig"
 source "drivers/media/platform/nxp/Kconfig"
+source "drivers/media/platform/nxp/amphion/Kconfig"
 source "drivers/media/platform/omap/Kconfig"
 source "drivers/media/platform/omap3isp/Kconfig"
 source "drivers/media/platform/qcom/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index ce9909534218..7a28b60dbbe6 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -9,7 +9,6 @@ obj-y += allegro-dvt/
 obj-y += allwinner/
 obj-y += am437x/
 obj-y += amlogic/meson-ge2d/
-obj-y += amphion/
 obj-y += aspeed/
 obj-y += atmel/
 obj-y += cadence/
@@ -25,6 +24,7 @@ obj-y += mediatek/mtk-vcodec/
 obj-y += mediatek/mtk-vpu/
 obj-y += nvidia/tegra-vde/
 obj-y += nxp/
+obj-y += nxp/amphion/
 obj-y += omap/
 obj-y += omap3isp/
 obj-y += qcom/camss/
diff --git a/drivers/media/platform/amphion/Kconfig b/drivers/media/platform/nxp/amphion/Kconfig
similarity index 100%
rename from drivers/media/platform/amphion/Kconfig
rename to drivers/media/platform/nxp/amphion/Kconfig
diff --git a/drivers/media/platform/amphion/Makefile b/drivers/media/platform/nxp/amphion/Makefile
similarity index 100%
rename from drivers/media/platform/amphion/Makefile
rename to drivers/media/platform/nxp/amphion/Makefile
diff --git a/drivers/media/platform/amphion/vdec.c b/drivers/media/platform/nxp/amphion/vdec.c
similarity index 100%
rename from drivers/media/platform/amphion/vdec.c
rename to drivers/media/platform/nxp/amphion/vdec.c
diff --git a/drivers/media/platform/amphion/venc.c b/drivers/media/platform/nxp/amphion/venc.c
similarity index 100%
rename from drivers/media/platform/amphion/venc.c
rename to drivers/media/platform/nxp/amphion/venc.c
diff --git a/drivers/media/platform/amphion/vpu.h b/drivers/media/platform/nxp/amphion/vpu.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu.h
rename to drivers/media/platform/nxp/amphion/vpu.h
diff --git a/drivers/media/platform/amphion/vpu_cmds.c b/drivers/media/platform/nxp/amphion/vpu_cmds.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_cmds.c
rename to drivers/media/platform/nxp/amphion/vpu_cmds.c
diff --git a/drivers/media/platform/amphion/vpu_cmds.h b/drivers/media/platform/nxp/amphion/vpu_cmds.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_cmds.h
rename to drivers/media/platform/nxp/amphion/vpu_cmds.h
diff --git a/drivers/media/platform/amphion/vpu_codec.h b/drivers/media/platform/nxp/amphion/vpu_codec.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_codec.h
rename to drivers/media/platform/nxp/amphion/vpu_codec.h
diff --git a/drivers/media/platform/amphion/vpu_color.c b/drivers/media/platform/nxp/amphion/vpu_color.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_color.c
rename to drivers/media/platform/nxp/amphion/vpu_color.c
diff --git a/drivers/media/platform/amphion/vpu_core.c b/drivers/media/platform/nxp/amphion/vpu_core.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_core.c
rename to drivers/media/platform/nxp/amphion/vpu_core.c
diff --git a/drivers/media/platform/amphion/vpu_core.h b/drivers/media/platform/nxp/amphion/vpu_core.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_core.h
rename to drivers/media/platform/nxp/amphion/vpu_core.h
diff --git a/drivers/media/platform/amphion/vpu_dbg.c b/drivers/media/platform/nxp/amphion/vpu_dbg.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_dbg.c
rename to drivers/media/platform/nxp/amphion/vpu_dbg.c
diff --git a/drivers/media/platform/amphion/vpu_defs.h b/drivers/media/platform/nxp/amphion/vpu_defs.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_defs.h
rename to drivers/media/platform/nxp/amphion/vpu_defs.h
diff --git a/drivers/media/platform/amphion/vpu_drv.c b/drivers/media/platform/nxp/amphion/vpu_drv.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_drv.c
rename to drivers/media/platform/nxp/amphion/vpu_drv.c
diff --git a/drivers/media/platform/amphion/vpu_helpers.c b/drivers/media/platform/nxp/amphion/vpu_helpers.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_helpers.c
rename to drivers/media/platform/nxp/amphion/vpu_helpers.c
diff --git a/drivers/media/platform/amphion/vpu_helpers.h b/drivers/media/platform/nxp/amphion/vpu_helpers.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_helpers.h
rename to drivers/media/platform/nxp/amphion/vpu_helpers.h
diff --git a/drivers/media/platform/amphion/vpu_imx8q.c b/drivers/media/platform/nxp/amphion/vpu_imx8q.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_imx8q.c
rename to drivers/media/platform/nxp/amphion/vpu_imx8q.c
diff --git a/drivers/media/platform/amphion/vpu_imx8q.h b/drivers/media/platform/nxp/amphion/vpu_imx8q.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_imx8q.h
rename to drivers/media/platform/nxp/amphion/vpu_imx8q.h
diff --git a/drivers/media/platform/amphion/vpu_malone.c b/drivers/media/platform/nxp/amphion/vpu_malone.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_malone.c
rename to drivers/media/platform/nxp/amphion/vpu_malone.c
diff --git a/drivers/media/platform/amphion/vpu_malone.h b/drivers/media/platform/nxp/amphion/vpu_malone.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_malone.h
rename to drivers/media/platform/nxp/amphion/vpu_malone.h
diff --git a/drivers/media/platform/amphion/vpu_mbox.c b/drivers/media/platform/nxp/amphion/vpu_mbox.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_mbox.c
rename to drivers/media/platform/nxp/amphion/vpu_mbox.c
diff --git a/drivers/media/platform/amphion/vpu_mbox.h b/drivers/media/platform/nxp/amphion/vpu_mbox.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_mbox.h
rename to drivers/media/platform/nxp/amphion/vpu_mbox.h
diff --git a/drivers/media/platform/amphion/vpu_msgs.c b/drivers/media/platform/nxp/amphion/vpu_msgs.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_msgs.c
rename to drivers/media/platform/nxp/amphion/vpu_msgs.c
diff --git a/drivers/media/platform/amphion/vpu_msgs.h b/drivers/media/platform/nxp/amphion/vpu_msgs.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_msgs.h
rename to drivers/media/platform/nxp/amphion/vpu_msgs.h
diff --git a/drivers/media/platform/amphion/vpu_rpc.c b/drivers/media/platform/nxp/amphion/vpu_rpc.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_rpc.c
rename to drivers/media/platform/nxp/amphion/vpu_rpc.c
diff --git a/drivers/media/platform/amphion/vpu_rpc.h b/drivers/media/platform/nxp/amphion/vpu_rpc.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_rpc.h
rename to drivers/media/platform/nxp/amphion/vpu_rpc.h
diff --git a/drivers/media/platform/amphion/vpu_v4l2.c b/drivers/media/platform/nxp/amphion/vpu_v4l2.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_v4l2.c
rename to drivers/media/platform/nxp/amphion/vpu_v4l2.c
diff --git a/drivers/media/platform/amphion/vpu_v4l2.h b/drivers/media/platform/nxp/amphion/vpu_v4l2.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_v4l2.h
rename to drivers/media/platform/nxp/amphion/vpu_v4l2.h
diff --git a/drivers/media/platform/amphion/vpu_windsor.c b/drivers/media/platform/nxp/amphion/vpu_windsor.c
similarity index 100%
rename from drivers/media/platform/amphion/vpu_windsor.c
rename to drivers/media/platform/nxp/amphion/vpu_windsor.c
diff --git a/drivers/media/platform/amphion/vpu_windsor.h b/drivers/media/platform/nxp/amphion/vpu_windsor.h
similarity index 100%
rename from drivers/media/platform/amphion/vpu_windsor.h
rename to drivers/media/platform/nxp/amphion/vpu_windsor.h