diff --git a/MAINTAINERS b/MAINTAINERS
index 4cf03d253bc8..6c1055c27c65 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -2710,7 +2710,7 @@ F:	drivers/clocksource/clksrc_st_lpc.c
 F:	drivers/cpufreq/sti-cpufreq.c
 F:	drivers/dma/st_fdma*
 F:	drivers/i2c/busses/i2c-st.c
-F:	drivers/media/platform/sti/c8sectpfe/
+F:	drivers/media/platform/stm/sti/c8sectpfe/
 F:	drivers/media/rc/st_rc.c
 F:	drivers/mmc/host/sdhci-st.c
 F:	drivers/phy/st/phy-miphy28lp.c
@@ -3383,7 +3383,7 @@ L:	linux-media@vger.kernel.org
 S:	Supported
 W:	https://linuxtv.org
 T:	git git://linuxtv.org/media_tree.git
-F:	drivers/media/platform/sti/bdisp
+F:	drivers/media/platform/stm/sti/bdisp
 
 BECKHOFF CX5020 ETHERCAT MASTER DRIVER
 M:	Dariusz Marcinkiewicz <reksio@newterm.pl>
@@ -5482,7 +5482,7 @@ L:	linux-media@vger.kernel.org
 S:	Supported
 W:	https://linuxtv.org
 T:	git git://linuxtv.org/media_tree.git
-F:	drivers/media/platform/sti/delta
+F:	drivers/media/platform/stm/sti/delta
 
 DELTA AHE-50DC FAN CONTROL MODULE DRIVER
 M:	Zev Weiss <zev@bewilderbeest.net>
@@ -8870,7 +8870,7 @@ L:	linux-media@vger.kernel.org
 S:	Supported
 W:	https://linuxtv.org
 T:	git git://linuxtv.org/media_tree.git
-F:	drivers/media/platform/sti/hva
+F:	drivers/media/platform/stm/sti/hva
 
 HWPOISON MEMORY FAILURE HANDLING
 M:	Naoya Horiguchi <naoya.horiguchi@nec.com>
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index c308de1a42a4..2ad5fde02543 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -94,7 +94,7 @@ source "drivers/media/platform/samsung/s3c-camif/Kconfig"
 source "drivers/media/platform/samsung/s5p-g2d/Kconfig"
 source "drivers/media/platform/samsung/s5p-jpeg/Kconfig"
 source "drivers/media/platform/samsung/s5p-mfc/Kconfig"
-source "drivers/media/platform/sti/Kconfig"
+source "drivers/media/platform/stm/sti/Kconfig"
 source "drivers/media/platform/stm/stm32/Kconfig"
 source "drivers/media/platform/ti-vpe/Kconfig"
 source "drivers/media/platform/via/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index 7f077c9a416d..f20f1287c665 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -36,10 +36,10 @@ obj-y += samsung/s3c-camif/
 obj-y += samsung/s5p-g2d/
 obj-y += samsung/s5p-jpeg/
 obj-y += samsung/s5p-mfc/
-obj-y += sti/bdisp/
-obj-y += sti/c8sectpfe/
-obj-y += sti/delta/
-obj-y += sti/hva/
+obj-y += stm/sti/bdisp/
+obj-y += stm/sti/c8sectpfe/
+obj-y += stm/sti/delta/
+obj-y += stm/sti/hva/
 obj-y += stm/stm32/
 obj-y += ti-vpe/
 obj-y += via/
diff --git a/drivers/media/platform/sti/Kconfig b/drivers/media/platform/sti/Kconfig
deleted file mode 100644
index 9fb5e78a92cf..000000000000
--- a/drivers/media/platform/sti/Kconfig
+++ /dev/null
@@ -1,5 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0-only
-source "drivers/media/platform/sti/bdisp/Kconfig"
-source "drivers/media/platform/sti/c8sectpfe/Kconfig"
-source "drivers/media/platform/sti/delta/Kconfig"
-source "drivers/media/platform/sti/hva/Kconfig"
diff --git a/drivers/media/platform/stm/sti/Kconfig b/drivers/media/platform/stm/sti/Kconfig
new file mode 100644
index 000000000000..311930644281
--- /dev/null
+++ b/drivers/media/platform/stm/sti/Kconfig
@@ -0,0 +1,5 @@
+# SPDX-License-Identifier: GPL-2.0-only
+source "drivers/media/platform/stm/sti/bdisp/Kconfig"
+source "drivers/media/platform/stm/sti/c8sectpfe/Kconfig"
+source "drivers/media/platform/stm/sti/delta/Kconfig"
+source "drivers/media/platform/stm/sti/hva/Kconfig"
diff --git a/drivers/media/platform/sti/bdisp/Kconfig b/drivers/media/platform/stm/sti/bdisp/Kconfig
similarity index 100%
rename from drivers/media/platform/sti/bdisp/Kconfig
rename to drivers/media/platform/stm/sti/bdisp/Kconfig
diff --git a/drivers/media/platform/sti/bdisp/Makefile b/drivers/media/platform/stm/sti/bdisp/Makefile
similarity index 100%
rename from drivers/media/platform/sti/bdisp/Makefile
rename to drivers/media/platform/stm/sti/bdisp/Makefile
diff --git a/drivers/media/platform/sti/bdisp/bdisp-debug.c b/drivers/media/platform/stm/sti/bdisp/bdisp-debug.c
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp-debug.c
rename to drivers/media/platform/stm/sti/bdisp/bdisp-debug.c
diff --git a/drivers/media/platform/sti/bdisp/bdisp-filter.h b/drivers/media/platform/stm/sti/bdisp/bdisp-filter.h
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp-filter.h
rename to drivers/media/platform/stm/sti/bdisp/bdisp-filter.h
diff --git a/drivers/media/platform/sti/bdisp/bdisp-hw.c b/drivers/media/platform/stm/sti/bdisp/bdisp-hw.c
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp-hw.c
rename to drivers/media/platform/stm/sti/bdisp/bdisp-hw.c
diff --git a/drivers/media/platform/sti/bdisp/bdisp-reg.h b/drivers/media/platform/stm/sti/bdisp/bdisp-reg.h
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp-reg.h
rename to drivers/media/platform/stm/sti/bdisp/bdisp-reg.h
diff --git a/drivers/media/platform/sti/bdisp/bdisp-v4l2.c b/drivers/media/platform/stm/sti/bdisp/bdisp-v4l2.c
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp-v4l2.c
rename to drivers/media/platform/stm/sti/bdisp/bdisp-v4l2.c
diff --git a/drivers/media/platform/sti/bdisp/bdisp.h b/drivers/media/platform/stm/sti/bdisp/bdisp.h
similarity index 100%
rename from drivers/media/platform/sti/bdisp/bdisp.h
rename to drivers/media/platform/stm/sti/bdisp/bdisp.h
diff --git a/drivers/media/platform/sti/c8sectpfe/Kconfig b/drivers/media/platform/stm/sti/c8sectpfe/Kconfig
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/Kconfig
rename to drivers/media/platform/stm/sti/c8sectpfe/Kconfig
diff --git a/drivers/media/platform/sti/c8sectpfe/Makefile b/drivers/media/platform/stm/sti/c8sectpfe/Makefile
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/Makefile
rename to drivers/media/platform/stm/sti/c8sectpfe/Makefile
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-common.c b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-common.c
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-common.c
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-common.c
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-common.h b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-common.h
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-common.h
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-common.h
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-core.c b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-core.c
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-core.c
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-core.c
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-core.h b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-core.h
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-core.h
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-core.h
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-debugfs.c b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-debugfs.c
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-debugfs.c
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-debugfs.c
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-debugfs.h b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-debugfs.h
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-debugfs.h
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-debugfs.h
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-dvb.c b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-dvb.c
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-dvb.c
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-dvb.c
diff --git a/drivers/media/platform/sti/c8sectpfe/c8sectpfe-dvb.h b/drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-dvb.h
similarity index 100%
rename from drivers/media/platform/sti/c8sectpfe/c8sectpfe-dvb.h
rename to drivers/media/platform/stm/sti/c8sectpfe/c8sectpfe-dvb.h
diff --git a/drivers/media/platform/sti/delta/Kconfig b/drivers/media/platform/stm/sti/delta/Kconfig
similarity index 100%
rename from drivers/media/platform/sti/delta/Kconfig
rename to drivers/media/platform/stm/sti/delta/Kconfig
diff --git a/drivers/media/platform/sti/delta/Makefile b/drivers/media/platform/stm/sti/delta/Makefile
similarity index 100%
rename from drivers/media/platform/sti/delta/Makefile
rename to drivers/media/platform/stm/sti/delta/Makefile
diff --git a/drivers/media/platform/sti/delta/delta-cfg.h b/drivers/media/platform/stm/sti/delta/delta-cfg.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-cfg.h
rename to drivers/media/platform/stm/sti/delta/delta-cfg.h
diff --git a/drivers/media/platform/sti/delta/delta-debug.c b/drivers/media/platform/stm/sti/delta/delta-debug.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-debug.c
rename to drivers/media/platform/stm/sti/delta/delta-debug.c
diff --git a/drivers/media/platform/sti/delta/delta-debug.h b/drivers/media/platform/stm/sti/delta/delta-debug.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-debug.h
rename to drivers/media/platform/stm/sti/delta/delta-debug.h
diff --git a/drivers/media/platform/sti/delta/delta-ipc.c b/drivers/media/platform/stm/sti/delta/delta-ipc.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-ipc.c
rename to drivers/media/platform/stm/sti/delta/delta-ipc.c
diff --git a/drivers/media/platform/sti/delta/delta-ipc.h b/drivers/media/platform/stm/sti/delta/delta-ipc.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-ipc.h
rename to drivers/media/platform/stm/sti/delta/delta-ipc.h
diff --git a/drivers/media/platform/sti/delta/delta-mem.c b/drivers/media/platform/stm/sti/delta/delta-mem.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mem.c
rename to drivers/media/platform/stm/sti/delta/delta-mem.c
diff --git a/drivers/media/platform/sti/delta/delta-mem.h b/drivers/media/platform/stm/sti/delta/delta-mem.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mem.h
rename to drivers/media/platform/stm/sti/delta/delta-mem.h
diff --git a/drivers/media/platform/sti/delta/delta-mjpeg-dec.c b/drivers/media/platform/stm/sti/delta/delta-mjpeg-dec.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mjpeg-dec.c
rename to drivers/media/platform/stm/sti/delta/delta-mjpeg-dec.c
diff --git a/drivers/media/platform/sti/delta/delta-mjpeg-fw.h b/drivers/media/platform/stm/sti/delta/delta-mjpeg-fw.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mjpeg-fw.h
rename to drivers/media/platform/stm/sti/delta/delta-mjpeg-fw.h
diff --git a/drivers/media/platform/sti/delta/delta-mjpeg-hdr.c b/drivers/media/platform/stm/sti/delta/delta-mjpeg-hdr.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mjpeg-hdr.c
rename to drivers/media/platform/stm/sti/delta/delta-mjpeg-hdr.c
diff --git a/drivers/media/platform/sti/delta/delta-mjpeg.h b/drivers/media/platform/stm/sti/delta/delta-mjpeg.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-mjpeg.h
rename to drivers/media/platform/stm/sti/delta/delta-mjpeg.h
diff --git a/drivers/media/platform/sti/delta/delta-v4l2.c b/drivers/media/platform/stm/sti/delta/delta-v4l2.c
similarity index 100%
rename from drivers/media/platform/sti/delta/delta-v4l2.c
rename to drivers/media/platform/stm/sti/delta/delta-v4l2.c
diff --git a/drivers/media/platform/sti/delta/delta.h b/drivers/media/platform/stm/sti/delta/delta.h
similarity index 100%
rename from drivers/media/platform/sti/delta/delta.h
rename to drivers/media/platform/stm/sti/delta/delta.h
diff --git a/drivers/media/platform/sti/hva/Kconfig b/drivers/media/platform/stm/sti/hva/Kconfig
similarity index 100%
rename from drivers/media/platform/sti/hva/Kconfig
rename to drivers/media/platform/stm/sti/hva/Kconfig
diff --git a/drivers/media/platform/sti/hva/Makefile b/drivers/media/platform/stm/sti/hva/Makefile
similarity index 100%
rename from drivers/media/platform/sti/hva/Makefile
rename to drivers/media/platform/stm/sti/hva/Makefile
diff --git a/drivers/media/platform/sti/hva/hva-debugfs.c b/drivers/media/platform/stm/sti/hva/hva-debugfs.c
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-debugfs.c
rename to drivers/media/platform/stm/sti/hva/hva-debugfs.c
diff --git a/drivers/media/platform/sti/hva/hva-h264.c b/drivers/media/platform/stm/sti/hva/hva-h264.c
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-h264.c
rename to drivers/media/platform/stm/sti/hva/hva-h264.c
diff --git a/drivers/media/platform/sti/hva/hva-hw.c b/drivers/media/platform/stm/sti/hva/hva-hw.c
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-hw.c
rename to drivers/media/platform/stm/sti/hva/hva-hw.c
diff --git a/drivers/media/platform/sti/hva/hva-hw.h b/drivers/media/platform/stm/sti/hva/hva-hw.h
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-hw.h
rename to drivers/media/platform/stm/sti/hva/hva-hw.h
diff --git a/drivers/media/platform/sti/hva/hva-mem.c b/drivers/media/platform/stm/sti/hva/hva-mem.c
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-mem.c
rename to drivers/media/platform/stm/sti/hva/hva-mem.c
diff --git a/drivers/media/platform/sti/hva/hva-mem.h b/drivers/media/platform/stm/sti/hva/hva-mem.h
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-mem.h
rename to drivers/media/platform/stm/sti/hva/hva-mem.h
diff --git a/drivers/media/platform/sti/hva/hva-v4l2.c b/drivers/media/platform/stm/sti/hva/hva-v4l2.c
similarity index 100%
rename from drivers/media/platform/sti/hva/hva-v4l2.c
rename to drivers/media/platform/stm/sti/hva/hva-v4l2.c
diff --git a/drivers/media/platform/sti/hva/hva.h b/drivers/media/platform/stm/sti/hva/hva.h
similarity index 100%
rename from drivers/media/platform/sti/hva/hva.h
rename to drivers/media/platform/stm/sti/hva/hva.h